Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmViewer.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmViewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmViewer.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLXmViewer.cc,v 1.23 2006/06/29 21:20:16 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// $Id: G4OpenGLXmViewer.cc,v 1.24 2007/08/21 14:05:51 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -616,5 +616,5 @@
 rot_sens_limit (90.),
 pan_sens_limit (100.),
-rot_sens (4.),
+rot_sens (1.),
 wob_sens (20.),
 original_vp(fVP.GetViewpointDirection()),
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmViewerMessenger.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmViewerMessenger.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmViewerMessenger.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmViewerMessenger.cc,v 1.4 2006/06/29 21:20:18 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 #ifdef G4VIS_BUILD_OPENGLXM_DRIVER
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmWindowHandlingCallbacks.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmWindowHandlingCallbacks.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmWindowHandlingCallbacks.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmWindowHandlingCallbacks.cc,v 1.6 2006/06/29 21:20:20 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/History
===================================================================
--- trunk/geant4/visualization/OpenInventor/History	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/History	(revision 593)
@@ -1,3 +1,3 @@
-$Id: History,v 1.90 2006/11/05 20:49:09 allison Exp $
+$Id: History,v 1.93 2007/04/03 13:35:48 allison Exp $
 -------------------------------------------------------------------
 
@@ -20,4 +20,15 @@
 History file for visualization/OpenInventor
 -------------------------------------------
+
+3rd April 2007  John Allison  (openinventor-V08-02-02 - needs visman-V08-02-03)
+- Introduced picking control.  Default is "true" for Open Inventor.
+
+25th March 2007  John Allison  (openinventor-V08-02-01)
+- G4OpenInventorSceneHandler: Introduced AddProperties. Rationalises.
+- G4OpenInventorViewer.cc: Added scale factor to list of changes
+  requiring kernel visit.
+
+5th January 2007  John Allison  (openinventor-V08-02-00)
+- Moved LoadAtts to vis management.
 
 5th November 2006  John Allison  (openinventor-V08-01-04)
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventor.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventor.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventor.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventor.hh,v 1.9 2006/06/29 21:20:22 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // Guy Barrand 26 Mar 1998.
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorSceneHandler.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorSceneHandler.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorSceneHandler.hh	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenInventorSceneHandler.hh,v 1.31 2006/11/02 12:01:20 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenInventorSceneHandler.hh,v 1.33 2007/03/27 15:24:15 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -48,5 +48,5 @@
 class SoSeparator;
 class Geant4_SoStyleCache;
-class G4AttHolder;
+class G4VisAttributes;
 
 // Base class for various OpenInventorScene classes.
@@ -86,9 +86,9 @@
 private:
 
-  void LoadAtts(const G4Visible&, G4AttHolder*);
   static G4int fSceneIdCount;   // static counter for OpenInventor scenes.
   enum G4OIMarker {G4OICircle, G4OISquare};
   void AddCircleSquare (G4OIMarker markerType, const G4VMarker&);
   void GeneratePrerequisites();
+  void AddProperties(const G4VisAttributes*);
   std::map <G4LogicalVolume*, SoSeparator*,
     std::less <G4LogicalVolume*> > fSeparatorMap;
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorTransform3D.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorTransform3D.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorTransform3D.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorTransform3D.hh,v 1.7 2006/06/29 21:20:26 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWin.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWin.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWin.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorWin.hh,v 1.3 2006/06/29 21:20:30 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // OpenInventor graphics system factory.
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWin32.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWin32.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWin32.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorWin32.hh,v 1.7 2006/06/29 21:20:32 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // OpenInventor graphics system factory.
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWinViewer.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWinViewer.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorWinViewer.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorWinViewer.hh,v 1.9 2006/06/29 21:20:34 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorX.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorX.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorX.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorX.hh,v 1.7 2006/06/29 21:20:36 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorXt.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorXt.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorXt.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorXt.hh,v 1.3 2006/06/29 21:20:38 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/include/G4OpenInventorXtViewer.hh
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/G4OpenInventorXtViewer.hh	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/G4OpenInventorXtViewer.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorXtViewer.hh,v 1.14 2006/06/29 21:20:40 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/include/HEPVis/SbMath.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/HEPVis/SbMath.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/HEPVis/SbMath.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SbMath.h,v 1.4 2006/06/29 21:20:46 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 #ifndef HEPVis_SbMath_h
Index: trunk/geant4/visualization/OpenInventor/include/HEPVis/nodekits/SoDetectorTreeKit.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/HEPVis/nodekits/SoDetectorTreeKit.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/HEPVis/nodekits/SoDetectorTreeKit.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SoDetectorTreeKit.h,v 1.5 2006/06/29 21:21:16 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------HEPVis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoBox.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoBox.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoBox.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SoBox.h,v 1.3 2006/06/29 21:21:18 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------Hepvis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoCons.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoCons.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoCons.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SoCons.h,v 1.3 2006/06/29 21:21:20 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------Hepvis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTrap.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTrap.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTrap.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SoTrap.h,v 1.4 2006/06/29 21:22:06 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------Hepvis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTrd.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTrd.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTrd.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SoTrd.h,v 1.3 2006/06/29 21:22:08 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------Hepvis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTubs.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTubs.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/HEPVis/nodes/SoTubs.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SoTubs.h,v 1.3 2006/06/29 21:22:10 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------Hepvis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/include/SoG4LineSet.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/SoG4LineSet.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/SoG4LineSet.h	(revision 593)
@@ -25,5 +25,5 @@
 //
 // $Id: SoG4LineSet.h,v 1.2 2006/12/13 15:49:51 gunter Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // John Allison  26th October 2006
Index: trunk/geant4/visualization/OpenInventor/include/SoG4MarkerSet.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/SoG4MarkerSet.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/SoG4MarkerSet.h	(revision 593)
@@ -25,5 +25,5 @@
 //
 // $Id: SoG4MarkerSet.h,v 1.2 2006/12/13 15:49:53 gunter Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // John Allison  26th October 2006
Index: trunk/geant4/visualization/OpenInventor/include/SoG4Polyhedron.h
===================================================================
--- trunk/geant4/visualization/OpenInventor/include/SoG4Polyhedron.h	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/include/SoG4Polyhedron.h	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: SoG4Polyhedron.h,v 1.2 2006/12/13 15:49:56 gunter Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // John Allison  26th October 2006
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventor.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventor.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventor.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventor.cc,v 1.20 2006/06/29 21:22:12 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 #ifdef G4VIS_BUILD_OI_DRIVER
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventorSceneHandler.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventorSceneHandler.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventorSceneHandler.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenInventorSceneHandler.cc,v 1.50 2006/11/05 20:48:57 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenInventorSceneHandler.cc,v 1.53 2007/04/03 13:35:48 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -96,10 +96,4 @@
 #include "G4Trap.hh"
 #include "G4Trd.hh"
-#include "G4PhysicalVolumeModel.hh"
-#include "G4TrajectoriesModel.hh"
-#include "G4VTrajectory.hh"
-#include "G4VTrajectoryPoint.hh"
-#include "G4HitsModel.hh"
-#include "G4VHit.hh"
 #include "G4ModelingParameters.hh"
 #include "G4VPhysicalVolume.hh"
@@ -189,58 +183,11 @@
 }
 
-void G4OpenInventorSceneHandler::LoadAtts
-(const G4Visible& visible,
- G4AttHolder* holder)
-{
-  // Load G4Atts from G4VisAttributes, if any...
-  const std::map<G4String,G4AttDef>* vaDefs =
-    visible.GetVisAttributes()->GetAttDefs();
-  if (vaDefs) {
-    holder->AddAtts(visible.GetVisAttributes()->CreateAttValues(), vaDefs);
-  }
-
-  G4PhysicalVolumeModel* pPVModel =
-    dynamic_cast<G4PhysicalVolumeModel*>(fpModel);
-  if (pPVModel) {
-    // Load G4Atts from G4PhysicalVolumeModel...
-    const std::map<G4String,G4AttDef>* defs = pPVModel->GetAttDefs();
-    if (defs) {
-      holder->AddAtts(pPVModel->CreateCurrentAttValues(), defs);
-    }
-  }
-
-  G4TrajectoriesModel* trajModel = dynamic_cast<G4TrajectoriesModel*>(fpModel);
-  if (trajModel) {
-    // Load G4Atts from trajectory...
-    const G4VTrajectory* traj = trajModel->GetCurrentTrajectory();
-    const std::map<G4String,G4AttDef>* defs = traj->GetAttDefs();
-    if (defs) {
-      holder->AddAtts(traj->CreateAttValues(), defs);
-    }
-    G4int nPoints = traj->GetPointEntries();
-    for (G4int i = 0; i < nPoints; ++i) {
-      G4VTrajectoryPoint* trajPoint = traj->GetPoint(i);
-      const std::map<G4String,G4AttDef>* defs = trajPoint->GetAttDefs();
-      if (defs) {
-	holder->AddAtts(trajPoint->CreateAttValues(), defs);
-      }
-    }
-  }
-
-  G4HitsModel* hitsModel = dynamic_cast<G4HitsModel*>(fpModel);
-  if (hitsModel) {
-    // Load G4Atts from hit...
-    const G4VHit* hit = hitsModel->GetCurrentHit();
-    const std::map<G4String,G4AttDef>* defs = hit->GetAttDefs();
-    if (defs) {
-      holder->AddAtts(hit->CreateAttValues(), defs);
-    }
-  }
-}
-
 //
 // Method for handling G4Polyline objects (from tracking).
 //
-void G4OpenInventorSceneHandler::AddPrimitive (const G4Polyline& line) {
+void G4OpenInventorSceneHandler::AddPrimitive (const G4Polyline& line)
+{
+  AddProperties(line.GetVisAttributes());  // Transformation, colour, etc.
+
   G4int nPoints = line.size();
   SbVec3f* pCoords = new SbVec3f[nPoints];
@@ -252,17 +199,4 @@
   }
 
-  // Don't understand why I have to do this again (done in
-  // GeneratePrerequisites) - JA.
-  //
-  // Color
-  //
-  const G4Colour& c = GetColour (line);
-  SoMaterial* material = 
-    fStyleCache->getMaterial((float)c.GetRed(),
-                             (float)c.GetGreen(),
-                             (float)c.GetBlue(),
-                             (float)(1-c.GetAlpha()));
-  fCurrentSeparator->addChild(material);
-  
   //
   // Point Set
@@ -281,5 +215,5 @@
 
   // Loads G4Atts for picking...
-  LoadAtts(line, pLine);
+  if (fpViewer->GetViewParameters().IsPicking()) LoadAtts(line, pLine);
 
 #ifdef INVENTOR2_0
@@ -294,5 +228,8 @@
 }
 
-void G4OpenInventorSceneHandler::AddPrimitive (const G4Polymarker& polymarker) {
+void G4OpenInventorSceneHandler::AddPrimitive (const G4Polymarker& polymarker)
+{
+  AddProperties(polymarker.GetVisAttributes()); // Transformation, colour, etc.
+
   G4int pointn = polymarker.size();
   if(pointn<=0) return;
@@ -305,14 +242,4 @@
   }
 
-  // Don't understand why I have to do this again (done in
-  // GeneratePrerequisites) - JA.
-  const G4Colour& c = GetColour (polymarker);
-  SoMaterial* material = 
-    fStyleCache->getMaterial((float)c.GetRed(),
-                             (float)c.GetGreen(),
-                             (float)c.GetBlue(),
-                             (float)(1-c.GetAlpha()));
-  fCurrentSeparator->addChild(material);
-  
   SoCoordinate3* coordinate3 = new SoCoordinate3;
   coordinate3->point.setValues(0,pointn,points);
@@ -336,5 +263,6 @@
 
   // Loads G4Atts for picking...
-  LoadAtts(polymarker, markerSet);
+  if (fpViewer->GetViewParameters().IsPicking())
+    LoadAtts(polymarker, markerSet);
 
   G4VMarker::FillStyle style = polymarker.GetFillStyle();
@@ -410,8 +338,11 @@
 // Method for handling G4Text objects
 //
-void G4OpenInventorSceneHandler::AddPrimitive (const G4Text& text) {
+void G4OpenInventorSceneHandler::AddPrimitive (const G4Text& text)
+{
+  AddProperties(text.GetVisAttributes());  // Transformation, colour, etc.
+
   //
   // Color.  Note: text colour is worked out differently.  This
-  // over-rides the colour added in GeneratePrerequisites...
+  // over-rides the colour added in AddProperties...
   //
   const G4Colour& c = GetTextColour (text);
@@ -476,18 +407,7 @@
 
 void G4OpenInventorSceneHandler::AddCircleSquare
-(G4OIMarker markerType, const G4VMarker& marker) {
-
-  // Don't understand why I have to do this again (done in
-  // GeneratePrerequisites) - JA.
-  //
-  // Color
-  //
-  const G4Colour& c = GetColour (marker);
-  SoMaterial* material = 
-    fStyleCache->getMaterial((float)c.GetRed(),
-                             (float)c.GetGreen(),
-                             (float)c.GetBlue(),
-                             (float)(1-c.GetAlpha()));
-  fCurrentSeparator->addChild(material);
+(G4OIMarker markerType, const G4VMarker& marker)
+{
+  AddProperties(marker.GetVisAttributes());  // Transformation, colour, etc.
 
   MarkerSizeType sizeType;
@@ -519,5 +439,5 @@
 
   // Loads G4Atts for picking...
-  LoadAtts(marker, markerSet);
+  if (fpViewer->GetViewParameters().IsPicking()) LoadAtts(marker, markerSet);
 
   G4VMarker::FillStyle style = marker.GetFillStyle();
@@ -574,11 +494,15 @@
 // Method for handling G4Polyhedron objects for drawing solids.
 //
-void G4OpenInventorSceneHandler::AddPrimitive (const G4Polyhedron& polyhedron) {
+void G4OpenInventorSceneHandler::AddPrimitive (const G4Polyhedron& polyhedron)
+{
   if (polyhedron.GetNoFacets() == 0) return;
 
+  AddProperties(polyhedron.GetVisAttributes()); // Transformation, colour, etc.
+
   SoG4Polyhedron* soPolyhedron = new SoG4Polyhedron(polyhedron);
 
   // Loads G4Atts for picking...
-  LoadAtts(polyhedron, soPolyhedron);
+  if (fpViewer->GetViewParameters().IsPicking())
+    LoadAtts(polyhedron, soPolyhedron);
 
   SbString name = "Non-geometry";
@@ -600,4 +524,6 @@
 //
 void G4OpenInventorSceneHandler::AddPrimitive (const G4NURBS& nurb) {
+
+  AddProperties(nurb.GetVisAttributes()); // Transformation, colour, etc.
 
   G4float *u_knot_array, *u_knot_array_ptr;
@@ -618,15 +544,4 @@
   
   SoSeparator *surfSep = new SoSeparator();
-
-  //
-  // Color
-  //  
-  const G4Colour& c = GetColour (nurb);
-  SoMaterial* material = 
-    fStyleCache->getMaterial((float)c.GetRed(),
-                             (float)c.GetGreen(),
-                             (float)c.GetBlue(),
-                             (float)(1-c.GetAlpha()));
-  surfSep->addChild(material);
 
   //
@@ -686,33 +601,4 @@
   // location on in the scene database so that when the solid is
   // actually added (in addthis), it is put in the right place.
-
-  // Use the applicable vis attributes...
-  const G4VisAttributes* pApplicableVisAttribs =
-    fpViewer->GetApplicableVisAttributes (fpVisAttribs);
-
-  // First find the color attributes...
-  const G4Colour& g4Col =  pApplicableVisAttribs->GetColour ();
-  const double red = g4Col.GetRed ();
-  const double green = g4Col.GetGreen ();
-  const double blue = g4Col.GetBlue ();
-  double transparency = 1 - g4Col.GetAlpha();
-
-  // Drawing style...
-  G4ViewParameters::DrawingStyle drawing_style =
-    GetDrawingStyle(pApplicableVisAttribs);
-  switch (drawing_style) {
-  case (G4ViewParameters::wireframe):    
-    fModelingSolid = false;
-    break;
-  case (G4ViewParameters::hlr):
-  case (G4ViewParameters::hsr):
-  case (G4ViewParameters::hlhsr):
-    fModelingSolid = true;
-    break;
-  }	
-
-  // Edge visibility...
-  G4bool isAuxEdgeVisible = GetAuxEdgeVisible (pApplicableVisAttribs);
-  fReducedWireFrame = !isAuxEdgeVisible;
 
   G4PhysicalVolumeModel* pPVModel =
@@ -771,4 +657,31 @@
       if(fPreviewAndFull) detectorTreeKit->setPreviewAndFull();
       else detectorTreeKit->setPreview(TRUE);
+
+      // Colour, etc., for SoDetectorTreeKit.  Treated differently to
+      // othere SoNodes(?).  Use fpVisAttribs stored away in
+      // PreAddSolid...
+      const G4VisAttributes* pApplicableVisAttribs =
+	fpViewer->GetApplicableVisAttributes (fpVisAttribs);
+
+      // First find the color attributes...
+      const G4Colour& g4Col =  pApplicableVisAttribs->GetColour ();
+      const double red = g4Col.GetRed ();
+      const double green = g4Col.GetGreen ();
+      const double blue = g4Col.GetBlue ();
+      double transparency = 1 - g4Col.GetAlpha();
+
+      // Drawing style...
+      G4ViewParameters::DrawingStyle drawing_style =
+	GetDrawingStyle(pApplicableVisAttribs);
+      switch (drawing_style) {
+      case (G4ViewParameters::wireframe):    
+	fModelingSolid = false;
+	break;
+      case (G4ViewParameters::hlr):
+      case (G4ViewParameters::hsr):
+      case (G4ViewParameters::hlhsr):
+	fModelingSolid = true;
+	break;
+      }
 
       SoMaterial* material = 
@@ -853,4 +766,36 @@
     }
   }
+}
+
+void G4OpenInventorSceneHandler::AddProperties(const G4VisAttributes* visAtts)
+{
+  // Use the applicable vis attributes...
+  const G4VisAttributes* pApplicableVisAttribs =
+    fpViewer->GetApplicableVisAttributes (visAtts);
+
+  // First find the color attributes...
+  const G4Colour& g4Col =  pApplicableVisAttribs->GetColour ();
+  const double red = g4Col.GetRed ();
+  const double green = g4Col.GetGreen ();
+  const double blue = g4Col.GetBlue ();
+  double transparency = 1 - g4Col.GetAlpha();
+
+  // Drawing style...
+  G4ViewParameters::DrawingStyle drawing_style =
+    GetDrawingStyle(pApplicableVisAttribs);
+  switch (drawing_style) {
+  case (G4ViewParameters::wireframe):    
+    fModelingSolid = false;
+    break;
+  case (G4ViewParameters::hlr):
+  case (G4ViewParameters::hsr):
+  case (G4ViewParameters::hlhsr):
+    fModelingSolid = true;
+    break;
+  }
+
+  // Edge visibility...
+  G4bool isAuxEdgeVisible = GetAuxEdgeVisible (pApplicableVisAttribs);
+  fReducedWireFrame = !isAuxEdgeVisible;
 
   SoMaterial* material = 
@@ -883,4 +828,3 @@
   fCurrentSeparator->addChild(matrixTransform);
 }
-
 #endif
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventorTransform3D.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventorTransform3D.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventorTransform3D.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorTransform3D.cc,v 1.8 2006/06/29 21:22:16 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventorViewer.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventorViewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventorViewer.cc	(revision 593)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4OpenInventorViewer.cc,v 1.57 2006/11/01 11:06:07 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenInventorViewer.cc,v 1.59 2007/04/03 13:35:48 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 #ifdef G4VIS_BUILD_OI_DRIVER
@@ -69,6 +69,8 @@
   fNeedKernelVisit = true;  //?? Temporary, until KernelVisitDecision fixed.
 
+  fVP.SetAutoRefresh(true);
   fDefaultVP.SetAutoRefresh(true);
-  fVP.SetAutoRefresh(true);
+  fVP.SetPicking(true);
+  fDefaultVP.SetPicking(true);
 
   //FIXME : G.Barrand : not convinced that we have to rm culling.
@@ -175,8 +177,13 @@
       (vp.GetNoOfSides ()       != fVP.GetNoOfSides ())       ||
       (vp.IsMarkerNotHidden ()  != fVP.IsMarkerNotHidden ())  ||
-      (vp.GetBackgroundColour ()!= fVP.GetBackgroundColour ())
-      ) {
-      return true;;
-  }
+      (vp.GetBackgroundColour ()!= fVP.GetBackgroundColour ())||
+      (vp.IsPicking ()          != fVP.IsPicking ())          ||
+      // Scaling for Open Inventor is done by the scene handler so it
+      // needs a kernel visit.  (In this respect, it differs from the
+      // OpenGL drivers, where it's done in SetView.)
+      (vp.GetScaleFactor ()     != fVP.GetScaleFactor ())
+      )
+    return true;
+
   if (vp.IsDensityCulling () &&
       (vp.GetVisibleDensity () != fVP.GetVisibleDensity ()))
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventorWin.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventorWin.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventorWin.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorWin.cc,v 1.6 2006/06/29 21:22:20 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // OpenInventor graphics system factory.
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventorWinViewer.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventorWinViewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventorWinViewer.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorWinViewer.cc,v 1.25 2006/06/29 21:22:22 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventorXt.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventorXt.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventorXt.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorXt.cc,v 1.4 2006/06/29 21:22:24 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenInventor/src/G4OpenInventorXtViewer.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/G4OpenInventorXtViewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/G4OpenInventorXtViewer.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenInventorXtViewer.cc,v 1.24 2006/06/29 21:22:26 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*
Index: trunk/geant4/visualization/OpenInventor/src/SoBox.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/SoBox.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/SoBox.cc	(revision 593)
@@ -27,5 +27,5 @@
 //
 // $Id: SoBox.cc,v 1.8 2006/06/29 21:22:36 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*----------------------------HEPVis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/src/SoCons.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/SoCons.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/SoCons.cc	(revision 593)
@@ -27,5 +27,5 @@
 //
 // $Id: SoCons.cc,v 1.8 2006/06/29 21:22:38 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------HEPVis---------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/src/SoDetectorTreeKit.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/SoDetectorTreeKit.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/SoDetectorTreeKit.cc	(revision 593)
@@ -27,5 +27,5 @@
 //
 // $Id: SoDetectorTreeKit.cc,v 1.13 2006/06/29 21:22:51 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------HEPVis----------------------------------------*/
Index: trunk/geant4/visualization/OpenInventor/src/SoTrap.cc
===================================================================
--- trunk/geant4/visualization/OpenInventor/src/SoTrap.cc	(revision 592)
+++ trunk/geant4/visualization/OpenInventor/src/SoTrap.cc	(revision 593)
@@ -27,5 +27,5 @@
 //
 // $Id: SoTrap.cc,v 1.8 2006/06/29 21:23:03 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 /*-----------------------------HEPVis----------------------------------------*/
